/*
 * This header must be included by all source files
 *
 *
 */
#ifndef _H_MAINDATA_HH_
#define _H_MAINDATA_HH_
#include "types.h"
#include "global.h"
#include "fnt.h"

#define VERSIONNUMBER_STR "4.0"
#define VERSIONNUMBER_INT_LO 4
#define VERSIONNUMBER_INT_HI 0

GLOBAL_DATA g;

FNT *fnt1, *fnt2, *fnt3, *fnt4;    /* fixed fonts */
FNT *fnt5, *fnt6, *fnt7, *fnt8;    /* fixed fonts, big fonts */

/* global palette stuffs */
int     pl_x;           // position
int     pl_y;           // position
int     pl_sx;          // size of total element
int     pl_sy;          // size of total element
int     pl_dd;          // distance from outsize line
//...primary click area
int     pl_tx;          // position, rel. to pl_x
int     pl_ty;          // position, rel. to pl_y
int     pl_tsx;         // size of area
int     pl_tsy;         // size of area
//...secondary click area
int     pl_px;          // position, rel. to pl_x
int     pl_py;          // position, rel. to pl_y
int     pl_esx;         // elementsize
int     pl_esy;         // elementsize
int     pl_psx;         // secondary click area size...
int     pl_psy;
/* global sprite bar */
int     sp_x;
int     sp_y;
int     sp_sx;
int     sp_sy;
int     sp_esx;         // element size
int     sp_esy;         // element size
int     sp_mx;          // middle x, center box
int     sp_my;
/* Main button bar window */
int     bt_x;
int     bt_y;
int     bt_sx;
int     bt_sy;
int     bt_esx;         // element, buttonsize x
int     bt_esy;
int     bt_spx;
int     bt_spy;
/* Text Information window */
int     in_x;
int     in_y;
int     in_sx;
int     in_sy;
int     in_esx;
int     in_esy;
int     in_infostate;   // from 0 to 2 ( current information screen index )
BITMAP *in_bmp;
/* ToolBar button bar window  */
int     tb_x;
int     tb_y;
int     tb_sx;
int     tb_sy;
int     tb_esx;         // element, buttonsize x
int     tb_esy;
int     tb_spx;
int     tb_spy;
// BITMAP *EmptySpr;


/* Main sprite Editor window data */
int      md_x;
int      md_y;
int      md_sx;
int      md_sy;
int      md_zoom;
int      md_unzoom_x;   /* viewing window, unzoomed */
int      md_unzoom_y;
int      md_unzoom_sx;
int      md_unzoom_sy;
int      mc_s;          /* slider block size */
BITMAP   *ScaledMD;

/* ToolBar button bar window  */
int     tb_x;
int     tb_y;
int     tb_sx;
int     tb_sy;
int     tb_esx;         // element, buttonsize x
int     tb_esy;
int     tb_spx;         // space between buttons
int     tb_spy;
int     tb_asx;         // n buttons wide size
int     tb_asy;
BITMAP *tb_ibmp;        // info bitmap
BITMAP *tb_ibmp2;       // smaller info bitmap
int     tb_isx2;        // smaller infoblock size x
int     tb_isx;         // infoblock size x
int     tb_isy;         // infoblock size y
int     tb_ix2;         // smaller infoblock x, rel. to tb
int     tb_ix;          // infoblock x, rel. to tb
int     tb_iy;          // infoblock y, rel. to tb


// indexes into main_dialog[]
#define IDX_SLIDEX 0
#define IDX_SLIDEY 1
#define IDX_PALETT 2
#define IDX_MAINMD 3
#define IDX_SCLICK 4
#define IDX_INFOBLOCK 5
#define IDX_BUTTONARRAY 6
#define IDX_CHECK1 7
#define IDX_CHECK2 8
#define IDX_CHECK3 9
#define IDX_CHECK4 10
#define IDX_CHECK5 11
#define IDX_CHECK6 12
#define IDX_CHECK7 13
#define IDX_EXCHNG 14
#define IDX_TOOLBR 15
#define IDX_SPRITEBAR 16
#define IDX_BUTTONCOPY 17
#define IDX_BUTTONPASTE 18



extern      DIALOG     main_dialog[];
EXA_CLIP    clips, clipd;
EXA_FILL    fillstruct;
EXA_TEXT    text;
int         g_buttonarray_handle;


#endif
