/*
// a00.c // 1,0,0,1,0,  tocolorbitmap_rect         "copy button colors 1->3 all occurences."
 *
 *
 * **************************************************************** *
 *                                                                  *
 *  plugin button function                                          *
 *  button bitmaps are 32x32 pixels                                 *
 *                                                                  *
 * **************************************************************** *
 */
#include <stdio.h>              // for NULL
#include <allegro.h>
#include "import.h"
#include "mtds.h"
#include "dllinit.h"
#include "../global.h"
#include "../types.h"



/*  Icon bitmap types:
 *      background color    (transparency)
 *    * foreground color1
 *    # foreground color2
 *    $ foreground color3
 *    % foreground color4
 *    & foreground color5
 *    ( transparent mouse click area
 *    ) mouse foreground color1 click area
 *
 */

DLLEXPORT MTDS dxemod_params = {
"FLOKS",                        // CLASS
"i.p.",                         // author
__DATE__ ", " __TIME__,"0.1",   // date and version
"swapcolors 1&3",               // tooltips
"button colors 1&3, swap all occurences.",        // description
"Swap all colors in a image, using mousebutton colors 1 and 3.",  //help
"                              "
"                              "
"                              "
"     *******************      "
"     *******************      "
"     **               **      "
"     **               **      "
"     **               **      "
"  ********         ********   "
"   ******           ******    "
"    ****             ****     "
"     **               **      "
"                              "
"                              "
"                              "
"      *             ****      "
"     **             *****     "
"    ***               ***     "
"   ****                **     "
"   ****                **     "
"     **              ****     "
"     **              ****     "
"     **                **     "
"     **                **     "
"   ******             ***     "
"   ******           *****     "
"                    ****      "
"                              "
"                              "
"                              ",
"                              "
"                              "
"                              "
"        *************         "
"        *************         "
"        **         **         "
"        **         **         "
"        **         **         "
"     ********   ********      "
"      ******     ******       "
"       ****       ****        "
"        **         **         "
"                              "
"                              "
"                              "
"       *           ****       "
"      **           *****      "
"     ***             ***      "
"    ****              **      "
"    ****              **      "
"      **            ****      "
"      **            ****      "
"      **              **      "
"      **              **      "
"    ******           ***      "
"    ******         *****      "
"                   ****       "
"                              "
"                              "
"                              ",
1, // pre_callback_type   // 0=disabled,1=type1,2=type2  ( type of screen update )
0, // post_callback_type  // 0=disabled,1=type1,2=type2  ( type of screen update )
0, // invoke_dialog_flag  // 0=no or 1 (1= This plugin invokes a dialog)
1, // obey_loop_flag      // 0=no or 1=yes (multiple invocations)
0, // type                // 0=not defined yet, 1=grey, 4=rgb, 8=paletted
};     



DLLEXPORT void dxemod_init(){}
DLLEXPORT void dxemod_deinit(){}
/*
 *    Input:
 *   src  = bitmap
 *   x1   = coordinate x within bitmap
 *   y1   = coordinate y within bitmap
 *   sx   = size x
 *   sy   = size y
 *   Returns -1 on error, 0 on success
 */
DLLEXPORT int dxemod_method (BITMAP *src, int x1, int y1, int sx, int sy )
{
    int     x, y, c;
    int     color1, color2;

    if(src==NULL||x1<0||y1<0||sx<0||sy<0) return -1;   // failsafe
    color1 = g->usercolor1 & 255;
    color2 = g->usercolor3 & 255;
    for(y = y1 ; y < (y1+sy) ; y++) {
    for(x = x1 ; x < (x1+sx) ; x++) {
    c = v_getpixel(src,x,y) & 255;
    if ( c == color1 ) v_putpixel(src,x,y,color2);
    if ( c == color2 ) v_putpixel(src,x,y,color1);
    }}
    return 0;
}

