/*
 *
 *
 */
#include <stdio.h>
#include <allegro.h>
#include "import.h"
#include "mtds.h"
#include "dllinit.h"
#include "../global.h"
#include "../types.h"


DLLEXPORT MTDS dxemod_params = {
"BINOP",                                // CLASS
"i.p.",__DATE__ ", " __TIME__,"0.1",    // author, datetime, version
"fatso pixels",
"Expand binary image by one pixel",
"Expand image one pixel in x and y",
"                              "
"                              "
"                              "
"           *******            "
"         ***********          "
"        **         **         "
"       **  *******  **        "
"       ** *   **  * **        "
"       ** *   **  * **        "
"       ** ********* **        "
"       **  **   **  **        "
"        *** ***** ***         "
"          **     **           "
"     ********   ********      "
"    *********   *********     "
"    **                 **     "
"    *********   *********     "
"     ********   ********      "
"           **   **            "
"          **     **           "
"         **  ***  **          "
"        **  ** **  **         "
"       **  **   **  **        "
"      **  **     **  **       "
"      *****       *****       "
"       ***         ***        "
"                              "
"                              "
"                              "
"                              ",
"******************************"
"******************************"
"******************************"
"***********       ************"
"*********           **********"
"********  *********  *********"
"*******  **       **  ********"
"*******  * ***  ** *  ********"
"*******  * ***  ** *  ********"
"*******  *         *  ********"
"*******  **  ***   *  ********"
"********   *  *  *   *********"
"**********  *   *  ***********"
"***********       ************"
"*****        ***        ******"
"****  *****************  *****"
"****  **     ***     **  *****"
"*****    **  ***  **    ******"
"***********  ***  ************"
"**********  *  *  ************"
"*********  *    *  ***********"
"********  *  **  *  **********"
"*******  *  ****  *  *********"
"*******  *  ****  *  *********"
"*******    *****     *********"
"********  *******   **********"
"******************************"
"******************************"
"******************************"
"******************************",
1,2,0,1,0
};     

DLLEXPORT void dxemod_init()
{
    if( g->dxe_bitmap==NULL )
        g->dxe_bitmap = v_create_bitmap( g->sx+2, g->sy+2 );
}
DLLEXPORT void dxemod_deinit(){}
DLLEXPORT int dxemod_method (BITMAP *src, int x1, int y1, int sx, int sy )
{
    int     x,y;
    int     x2,x3,y2,y3, dx1,dx2,dy1,dy2, dx,dy, idx,idy, xlim,ylim;
    int     white, black;
    int     axx=0, ayy=0, flag_anchorx=0, flag_anchory=0;

    black = 0;
    white = 255;
    if( src==NULL ) return -1;

    dxemod_init();    if( g->dxe_bitmap==NULL ) return -1;
    v_clear_to_color(g->dxe_bitmap, black );
// ...........
    // scan x first, then each y
    ylim = y1+sy;
    xlim = x1+sx;
    for(y=y1;y<ylim;y++){
    for(x=x1;x<xlim;x++){
    x2 = x;   y2=y;     x3 = x+1;   if( x3 > (xlim-1) ) x3 = x1;
    dx1 =  v_getpixel(src, x2, y2 ) & 255;
    dx2 =  v_getpixel(src, x3, y2 ) & 255;
    dx = dx2 - dx1;    idx = dx1 - dx2;


    if( x < ((g->sx)-1) ){
    if( y < ((g->sy)-1) ){
    if( dx  > 15 ){
        if( flag_anchorx == 0 ){
        flag_anchorx = 1;
        axx = x2;
        }
        v_putpixel( g->dxe_bitmap,x2,y2, white );
    }
    if( idx  > 15 ){
        if( flag_anchorx == 1 ){
            flag_anchorx = 0;
            v_hline( g->dxe_bitmap, axx, y2, x2+1, white );
        }
        v_putpixel( g->dxe_bitmap,x2,y2, white );
    }


    }}  // within picture



    }
    flag_anchorx=0;
    }





// ...........
    // scan y first, then each x
    for(x=x1;x<xlim;x++){
    for(y=y1;y<ylim;y++){
    x2 = x;    y2 = y;    y3 = y+1;   if(y3 > (ylim-1)  ) y3 = y1;
    dy1 = v_getpixel(src, x2, y2 ) & 255;
    dy2 = v_getpixel(src, x2, y3 ) & 255;
    dy = dy2 - dy1;    idy = dy1 - dy2;
    if( x < ((g->sx)-1) ){
    if( y < ((g->sy)-1) ){

    if( dy  > 15 ){
        if( flag_anchory == 0 ){    flag_anchory = 1;   ayy = y2;   }
        v_putpixel( g->dxe_bitmap,x2,y2, white );
    }
    if( idy  > 15 ){
        if( flag_anchory == 1 ){        flag_anchory = 0;
        v_vline( g->dxe_bitmap, x2, ayy, y2+1, white );
        }
        v_putpixel( g->dxe_bitmap,x2,y2, white );
    }

    }}  // within picture
    }
    flag_anchory=0;
    }
// ...........
    v_blit( g->dxe_bitmap,src,  x1,y1,x1,y1,sx,sy );
    return 0;
}

