/* dllinit.c -- Portable DLL initialization.    (unused)

 */


#include <allegro.h>
#include <stdio.h>
#include "import.h"
#include "mtds.h"
#include "../global.h"


// imported symbols
BITMAP *(* v_create_bitmap)(int width, int height);
BITMAP *(* v_create_bitmap_ex)(int color_depth, int width, int height);
BITMAP *(* v_create_sub_bitmap)(BITMAP *parent, int x,int y,int width,int height);
void (* v_destroy_bitmap)(BITMAP *bitmap);
int  (* v_bitmap_color_depth)(BITMAP *bmp);
int  (* v_bitmap_mask_color)(BITMAP *bmp);
void (* v_set_clip)(BITMAP *bitmap, int x1, int y1, int x2, int y2);

BITMAP *(* v_load_bitmap)(const char *filename, RGB *pal);
int  (* v_save_bitmap)(const char *filename, BITMAP *bmp, const RGB *pal);
void (* v_register_bitmap_file_type)(const char *ext, BITMAP *(*load)(const char *filename, RGB *pal), int (*save)(const char *filename, BITMAP *bmp, const RGB *pal));
void (* v_set_color_conversion)(int mode);

void (* v_set_color)(int index, const RGB *p);
void (* v_set_palette)(const PALETTE p);
void (* v_get_color)(int index, RGB *p);
void (* v_get_palette)(PALETTE p);

int  (* v_makecol8)(int r, int g, int b);
int  (* v_makecol15)(int r, int g, int b);
int  (* v_makecol16)(int r, int g, int b);
int  (* v_makecol24)(int r, int g, int b);
int  (* v_makecol32)(int r, int g, int b);
int  (* v_makecol)(int r, int g, int b);
int  (* v_makecol_depth)(int color_depth, int r, int g, int b);

int  (* v_getr)(int c);
int  (* v_getg)(int c);
int  (* v_getb)(int c);
int  (* v_geta)(int c);
int  (* v_getr_depth)(int color_depth, int c);
int  (* v_getg_depth)(int color_depth, int c);
int  (* v_getb_depth)(int color_depth, int c);
int  (* v_geta_depth)(int color_depth, int c);

int  (* v_getpixel)(BITMAP *bmp, int x, int y);
void (* v_putpixel)(BITMAP *bmp, int x, int y, int color);
void (* v_vline)(BITMAP *bmp, int x, int y1, int y2, int color);
void (* v_hline)(BITMAP *bmp, int x1, int y, int x2, int color);
void (* v_do_line)(BITMAP *bmp, int x1, int y1, int x2, int y2, int d, void (*proc)(BITMAP *bmp, int x, int y, int d));
void (* v_line)(BITMAP *bmp, int x1, int y1, int x2, int y2, int color);
void (* v_triangle)(BITMAP *bmp, int x1, int y1, int x2,int y2, int x3, int y3, int color);
void (* v_polygon)(BITMAP *bmp, int vertices, int *points, int color);
void (* v_rect)(BITMAP *bmp, int x1, int y1, int x2, int y2, int color);
void (* v_rectfill)(BITMAP *bmp, int x1, int y1, int x2, int y2, int color);
void (* v_do_circle)(BITMAP *bmp, int x, int y, int radius, int d, void (*proc)(BITMAP *bmp, int x, int y, int d));
void (* v_circle)(BITMAP *bmp, int x, int y, int radius, int color);
void (* v_circlefill)(BITMAP *bmp, int x, int y, int radius, int color);
void (* v_do_ellipse)(BITMAP *bmp, int x, int y, int rx, int ry, int d, void (*proc)(BITMAP *bmp, int x, int y, int d));
void (* v_ellipse)(BITMAP *bmp, int x, int y, int rx, int ry, int color);
void (* v_ellipsefill)(BITMAP *bmp, int x, int y, int rx, int ry, int color);
void (* v_floodfill)(BITMAP *bmp, int x, int y, int color);

void (* v_clear_bitmap)(BITMAP *bitmap);
void (* v_clear)(BITMAP *bitmap);
void (* v_clear_to_color)(BITMAP *bitmap, int color);
void (* v_blit)(BITMAP *source, BITMAP *dest, int source_x, int source_y, int dest_x, int dest_y, int width, int height);
void (* v_masked_blit)(BITMAP *source, BITMAP *dest, int source_x, int source_y, int dest_x, int dest_y, int width, int height);
void (* v_stretch_blit)(BITMAP *source, BITMAP *dest, int source_x, int source_y, int source_width, int source_height, int dest_x, int dest_y, int dest_width, int dest_height);
void (* v_masked_stretch_blit)(BITMAP *source, BITMAP *dest, int source_x, int source_y, int source_w, int source_h, int dest_x, int dest_y, int dest_w, int dest_h);
void (* v_draw_sprite)(BITMAP *bmp, BITMAP *sprite, int x, int y);
void (* v_draw_sprite_v_flip)(BITMAP *bmp, BITMAP *sprite, int x, int y);
void (* v_draw_sprite_h_flip)(BITMAP *bmp, BITMAP *sprite, int x, int y);
void (* v_draw_sprite_vh_flip)(BITMAP *bmp, BITMAP *sprite, int x, int y);
void (* v_draw_character)(BITMAP *bmp, BITMAP *sprite, int x, int y, int color);
void (* v_rotate_sprite)(BITMAP *bmp, BITMAP *sprite, int x, int y, fixed angle);
void (* v_stretch_sprite)(BITMAP *bmp, BITMAP *sprite, int x, int y, int w, int h);

int  (* v_text_mode)(int mode);
void (* v_textout)(BITMAP *bmp, const FONT *f, const char *s, int x, int y, int color);
void (* v_textout_centre)(BITMAP *bmp, const FONT *f, const char *s, int x, int y, int color);
void (* v_textout_right)(BITMAP *bmp, const FONT *f, const char *s, int x, int y, int color);
void (* v_textout_justify)(BITMAP *bmp, const FONT *f, const char *s, int x1, int x2, int y, int diff, int color);
void (* v_textprintf)(BITMAP *bmp, const FONT *f, int x, int y, int color, const char *fmt, ...);
void (* v_textprintf_centre)(BITMAP *bmp, const FONT *f, int x, int y, int color, const char *fmt, ...);
void (* v_textprintf_right)(BITMAP *bmp, const FONT *f, int x, int y, int color, const char *fmt, ...);
void (* v_textprintf_justify)(BITMAP *bmp, const FONT *f, int x1, int x2, int y, int diff, int color, const char *fmt, ...);
int  (* v_text_length)(const FONT *f, const char *str);
int  (* v_text_height)(const FONT *f);
void (* v_destroy_font)(FONT *f);

int  (* v_bestfit_color)(const PALETTE pal, int r, int g, int b);
void (* v_hsv_to_rgb)(float h, float s, float v, int *r, int *g, int *b);
void (* v_rgb_to_hsv)(int r, int g, int b, float *h, float *s, float *v);

void (* v_scare_mouse)();
void (* v_unscare_mouse)();






DLLEXPORT void dxemod_import1(
    void *u_create_bitmap,
    void *u_create_bitmap_ex,
    void *u_create_sub_bitmap,
    void *u_destroy_bitmap,
    void *u_bitmap_color_depth,
    void *u_bitmap_mask_color,
    void *u_set_clip,
    void *u_load_bitmap,
    void *u_save_bitmap,
    void *u_register_bitmap_file_type,
    void *u_set_color_conversion,
    void *u_set_color,
    void *u_set_palette,
    void *u_get_color,
    void *u_get_palette,
    void *u_makecol8,
    void *u_makecol15,
    void *u_makecol16,
    void *u_makecol24,
    void *u_makecol32,
    void *u_makecol,
    void *u_makecol_depth,
    void *u_getr,
    void *u_getg,
    void *u_getb,
    void *u_geta,
    void *u_getr_depth,
    void *u_getg_depth,
    void *u_getb_depth,
    void *u_geta_depth,
    void *u_getpixel,
    void *u_putpixel,
    void *u_vline,
    void *u_hline,
    void *u_do_line,
    void *u_line,
    void *u_triangle,
    void *u_polygon,
    void *u_rect,
    void *u_rectfill,
    void *u_do_circle,
    void *u_circle,
    void *u_circlefill,
    void *u_do_ellipse,
    void *u_ellipse,
    void *u_ellipsefill,
    void *u_floodfill,
    void *u_clear_bitmap,
    void *u_clear,
    void *u_clear_to_color,
    void *u_blit,
    void *u_masked_blit,
    void *u_stretch_blit,
    void *u_masked_stretch_blit,
    void *u_draw_sprite,
    void *u_draw_sprite_v_flip,
    void *u_draw_sprite_h_flip,
    void *u_draw_sprite_vh_flip,
    void *u_draw_character,
    void *u_rotate_sprite,
    void *u_stretch_sprite,
    void *u_text_mode,
    void *u_textout,
    void *u_textout_centre,
    void *u_textout_right,
    void *u_textout_justify,
    void *u_textprintf,
    void *u_textprintf_centre,
    void *u_textprintf_right,
    void *u_textprintf_justify,
    void *u_text_length,
    void *u_text_height,
    void *u_destroy_font,
    void *u_bestfit_color,
    void *u_hsv_to_rgb,
    void *u_rgb_to_hsv,
    void *u_scare_mouse,
    void *u_unscare_mouse )
{
    v_create_bitmap             = u_create_bitmap;
    v_create_bitmap_ex          = u_create_bitmap_ex;
    v_create_sub_bitmap         = u_create_sub_bitmap;
    v_destroy_bitmap            = u_destroy_bitmap;
    v_bitmap_color_depth        = u_bitmap_color_depth;
    v_bitmap_mask_color         = u_bitmap_mask_color;
    v_set_clip                  = u_set_clip;
    v_load_bitmap               = u_load_bitmap;
    v_save_bitmap               = u_save_bitmap;
    v_register_bitmap_file_type = u_register_bitmap_file_type;
    v_set_color_conversion      = u_set_color_conversion;
    v_set_color                 = u_set_color;
    v_set_palette               = u_set_palette;
    v_get_color                 = u_get_color;
    v_get_palette               = u_get_palette;
    v_makecol8                  = u_makecol8;
    v_makecol15                 = u_makecol15;
    v_makecol16                 = u_makecol16;
    v_makecol24                 = u_makecol24;
    v_makecol32                 = u_makecol32;
    v_makecol                   = u_makecol;
    v_makecol_depth             = u_makecol_depth;
    v_getr                      = u_getr;
    v_getg                      = u_getg;
    v_getb                      = u_getb;
    v_geta                      = u_geta;
    v_getr_depth                = u_getr_depth;
    v_getg_depth                = u_getg_depth;
    v_getb_depth                = u_getb_depth;
    v_geta_depth                = u_geta_depth;
    v_getpixel                  = u_getpixel;
    v_putpixel                  = u_putpixel;
    v_vline                     = u_vline;
    v_hline                     = u_hline;
    v_do_line                   = u_do_line;
    v_line                      = u_line;
    v_triangle                  = u_triangle;
    v_polygon                   = u_polygon;
    v_rect                      = u_rect;
    v_rectfill                  = u_rectfill;
    v_do_circle                 = u_do_circle;
    v_circle                    = u_circle;
    v_circlefill                = u_circlefill;
    v_do_ellipse                = u_do_ellipse;
    v_ellipse                   = u_ellipse;
    v_ellipsefill               = u_ellipsefill;
    v_floodfill                 = u_floodfill;
    v_clear_bitmap              = u_clear_bitmap;
    v_clear                     = u_clear;
    v_clear_to_color            = u_clear_to_color;
    v_blit                      = u_blit;
    v_masked_blit               = u_masked_blit;
    v_stretch_blit              = u_stretch_blit;
    v_masked_stretch_blit       = u_masked_stretch_blit;
    v_draw_sprite               = u_draw_sprite;
    v_draw_sprite_v_flip        = u_draw_sprite_v_flip;
    v_draw_sprite_h_flip        = u_draw_sprite_h_flip;
    v_draw_sprite_vh_flip       = u_draw_sprite_vh_flip;
    v_draw_character            = u_draw_character;
    v_rotate_sprite             = u_rotate_sprite;
    v_stretch_sprite            = u_stretch_sprite;
    v_text_mode                 = u_text_mode;
    v_textout                   = u_textout;
    v_textout_centre            = u_textout_centre;
    v_textout_right             = u_textout_right;
    v_textout_justify           = u_textout_justify;
    v_textprintf                = u_textprintf;
    v_textprintf_centre         = u_textprintf_centre;
    v_textprintf_right          = u_textprintf_right;
    v_textprintf_justify        = u_textprintf_justify;
    v_text_length               = u_text_length;
    v_text_height               = u_text_height;
    v_destroy_font              = u_destroy_font;
    v_bestfit_color             = u_bestfit_color;
    v_hsv_to_rgb                = u_hsv_to_rgb;
    v_rgb_to_hsv                = u_rgb_to_hsv;
    v_scare_mouse               = u_scare_mouse;
    v_unscare_mouse             = u_unscare_mouse;
}



unsigned char *(* v_ask_for_filename)( unsigned char *);
int     (* v_dlg_request_uchar)(char *, int, int, int);
int     (* v_dlg_request_short)(char *,int, int, int);
int     (* v_dlg_request_int)(char *,int, int, int );
double  (* v_dlg_request_float)(char *,float, float, float );
BITMAP *(* v_ll_get_sprite)( int );
double (* v_ceil)(double);
double (* v_pow)(double, double);
GLOBAL_DATA *g;



DLLEXPORT void dxemod_import2(
    void * u_ask_for_filename,
    void * u_dlg_request_uchar,
    void * u_dlg_request_short,
    void * u_dlg_request_int,
    void * u_dlg_request_float,
    void * u_ll_get_sprite,
    void * u_ceil,
    void * u_pow,
    void * u_g
    )
{
    v_ask_for_filename     =  u_ask_for_filename;
    v_dlg_request_uchar    =  u_dlg_request_uchar;
    v_dlg_request_short    =  u_dlg_request_short;
    v_dlg_request_int      =  u_dlg_request_int;
    v_dlg_request_float    =  u_dlg_request_float;
    v_ll_get_sprite        =  u_ll_get_sprite;
    v_ceil                 =  u_ceil;
    v_pow                  =  u_pow;
    g                      =  u_g;
}











