#ifndef _STANDARD_ERRDEFS_HH_
#define _STANDARD_ERRDEFS_HH_


#ifndef byte
#define byte  unsigned char
#define word  unsigned short
#define dword unsigned int
#endif

/*...sRead ahead structure and define */
#ifndef AHEAD_BUF
#define AHEAD_BUF 0x4000
#endif
typedef struct
{
/*    byte buf[AHEAD_BUF];*/
    byte *buf;
    int inx;
    int fd;
} AHEAD;
/*...e*/

/** from gbm.h **/
typedef int GBM_ERR;
#define GBM_ERR_OK          ((GBM_ERR) 0)
#define GBM_ERR_MEM         ((GBM_ERR) 1)
#define	GBM_ERR_NOT_SUPP	((GBM_ERR) 2)
#define	GBM_ERR_BAD_OPTION	((GBM_ERR) 3)
#define	GBM_ERR_NOT_FOUND	((GBM_ERR) 4)
#define	GBM_ERR_BAD_MAGIC	((GBM_ERR) 5)
#define	GBM_ERR_BAD_SIZE	((GBM_ERR) 6)
#define	GBM_ERR_READ		((GBM_ERR) 7)
#define GBM_ERR_WRITE       ((GBM_ERR) 8)
#define GBM_ERR_ARRAY       ((GBM_ERR) 9)
/* Functionality flags, combined     */
#define GBM_FT_R1       0x0001
#define	GBM_FT_R4		0x0002
#define	GBM_FT_R8		0x0004
#define	GBM_FT_R24		0x0008
#define	GBM_FT_W1		0x0010
#define	GBM_FT_W4		0x0020
#define	GBM_FT_W8		0x0040
#define	GBM_FT_W24		0x0080
#define PRIV_SIZE       2000
typedef struct { byte r, g, b; } GBMRGB;
typedef struct
{
	char *short_name;		/* Eg: "Targa"                       */
	char *long_name;		/* Eg: "Truevision Targa / Vista"    */
	char *extensions;		/* Eg: "TGA VST"                     */
    int flags;
} GBMFT;
typedef struct
{
	int w, h, bpp;			/* Bitmap dimensions                 */
    byte priv[PRIV_SIZE];   /* Private internal buffer           */
} GBM;

#endif
